/* =========================
   D88_P31
   by Koichi Nishida1
   (c)2013 Nishida Radio
==========================*/

#include <stdio.h>
#include <windows.h>
#include <shlwapi.h>
#include <tchar.h>
#pragma comment(lib, "shlwapi.lib")

#include "D88.H"

// create p31 from d88
void d88_p31(FILE *fp);

char *StrToUpper(char *s)
{
    char *p;  
 
    for (p = s; *p; p++) *p = toupper(*p);
	return s;
}

void conv(LPCTSTR name)
{
	FILE *fpw;
	TCHAR path[MAX_PATH];

	if (!name || !name[0]) return;

	if (StrCmp(StrToUpper(PathFindExtension(name)), TEXT(".D88")) != 0) {
		MessageBox(NULL, TEXT("Drop .D88 file."), TEXT("D88_P31"), MB_OK);
		return;
	}
	Init88();
	if (!Mount88((char *)name)) {
		MessageBox(NULL, TEXT("Can't open the D88 file."), TEXT("D88_P31"), MB_OK);
		return;
	}

	lstrcpy(path, name);
	PathRemoveExtension(path);
	PathAddExtension(path, TEXT(".P31"));

	if (fopen_s(&fpw,(char *)path,"wb")) {
		MessageBox(NULL, TEXT("Can't create P31 file."), TEXT("D88_P31"), MB_OK);
		Unmount88();
		return;
	}

	d88_p31(fpw);
	
	MessageBox(NULL, TEXT("the P31 image created."), TEXT("D88_P31"), MB_OK);
	Unmount88();
	fclose(fpw);
}

// create p31 from d88
void d88_p31(FILE *fp)
{	
	int trk, sct, i, j;
	unsigned char zero_buff[512], buff[256];
	unsigned char d1dd = (GetType()==0x10);

	for (i=0; i<512; i++) zero_buff[i] = 0;
	for (trk=0; trk<80; trk++) {
		sct = 0;
		while (Seek88(trk*(d1dd+1),++sct)) {
			for (i=0; i<256; i++) buff[i] = Getc88();
			fwrite(buff, 1, 256, fp);
			fwrite(zero_buff, 1, 256, fp);
		}
		for (j=sct; j<17; j++)
			fwrite(zero_buff, 1, 512, fp);
	}
}

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                     LPSTR lpCmdLine, int nCmdShow)
{
	conv(__targv[1]);
	return 0;
}