/*
 * COMU.h
 *
 * Created: 2016/03/29 14:55:58
 *  Author: koichi
 */ 

#ifndef COMU_H_
#define COMU_H_

#include <avr/io.h>

// <PORTA>
// communication bus with the CPLD (PIO)

// <PORTD>
// control outputs for communication with the CPLD (PIO)
// lower 2 bits: 00:portA, 01:portB, 10:portC
// read from the PIO when bit 2 is 1.
// write to the PIO when bit 3 is 1 (and bit 2 is 0).
// write to the direction register of the PIO when bit 4 is 1 (and bit 2 and bit 3 are 0).

//<PORTE>
// control inputs from the CPLD
// bit 0 is the reset signal from P6

void COMU_init(void);

void COMU_DIR_A(uint8_t d);
void COMU_DIR_B(uint8_t d);
void COMU_DIR_C(uint8_t d);

void COMU_OUT_A(uint8_t d);
void COMU_OUT_B(uint8_t d);
void COMU_OUT_C(uint8_t d);

uint8_t COMU_IN_A(void);
uint8_t COMU_IN_B(void);
uint8_t COMU_IN_C(void);

#endif /* COMU_H_ */