/*
 * SD6031Air.c
 *
 * Created: 2016/03/29 8:50:37
 *  Author: koichi
 */ 

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "LCD.h"
#include "COMMON.h"
#include "COMU.h"
#include "MOUNT.h"
#include "SD6031CORE.h"
#include "D88_P31.h"
#include "SD.h"
#include "BUFFER.h"

int main(void)
{
	uint8_t err = 0;

	// disable SPM
	CCP = CCP_IOREG_gc;
	NVM_CTRLB |= NVM_SPMLOCK_bm;

	// clock = 32MHz
	OSC.CTRL = OSC_RC32MEN_bm;
	while ((OSC.STATUS & OSC_RC32MRDY_bm)==0);
	CCP = CCP_IOREG_gc;						// allow changing CLK.CTRL
	CLK.CTRL = CLK_SCLKSEL_RC32M_gc;
	
	// clock output on PORTD PIN7
	PORTD.DIRSET =  PIN7_bm;
	PORTCFG.CLKEVOUT = PORTCFG_CLKOUT_PD7_gc;

	// VPORT0 = PORTA, VPORT1 = PORTC, VPORT2 = PORTD
	PORTCFG.VPCTRLA = PORTCFG_VP02MAP_PORTA_gc | PORTCFG_VP13MAP_PORTC_gc;
	PORTCFG.VPCTRLB = PORTCFG_VP02MAP_PORTD_gc;

#ifdef AIRDISP
	LCD_init();
#endif
	COMMON_init();

	if (GPIO0) {
#ifdef AIRDISP
		LCD_printAll("FirmwareWritten!");
#endif
		while (1);
	}

	SD6031_init();

	MOUNT_exchangeSD(1);

	SD6031_run();
}